open Atom
open Types

type coercion = 
  | CoId
      (* id *)
  | CoTrans of loc_coercion * loc_coercion 
      (* c1; c2 *)
  | CoIntroForall
      (* +forall *)
  | CoElimExists
      (* -exists *)
  | CoElimForall of bool *ftype
      (* -forall> t | -forall< t *)
  | CoIntroExists of bool *ftype
      (* +exists> t | +exists< t *)
  | CoArrow of loc_coercion * loc_coercion
      (* c1 -> c2 *)
  | CoQuantifier of quantifier * atom * loc_coercion
      (* all a. c *)
  | CoDistrib 
      (* distrib *)
  | CoDistribLabel of atom
      (* distrib l *)
  | CoRecord of loc_coercion AtomMap.t
      (* { l : c ) *)

and  loc_coercion =
    Error.location * coercion
